package main

import (
	"qzlogs"
	"strconv"
)

func main() {

	qzlogs.LogInit("D:\\work\\qzlogstest\\cmd", //ログファイル出力先フォルダ
		"QZ_TEST01_", //ログファイル名識別用prefix
		1,            //writeFlg 1行ログ、先頭の日付時間などのOption
		1,            //CrLfOpt  0...CR+LF 1...LF 2...CR
		0,            //LogSleepSw 0...ログ出力 1...ログ・スリープ(記録中止)
		0,            //LogLevel 1-5 レベルに合致したログメソッドのみ出力する
		1)            //utf8bom  0...UTF8 Bomなし　1...UTF8 Bomあり

	qzlogs.ProfileTimeStart("qzlogstest01")

	// パフォーマンス・テスト　2万行 Log書き込み
	//[SYSLOG][□--INFO--□] [qzlogstest01] 経過時間=0.077000[秒]
	//tid=20024:0.000000[ms][--- [QZ_TEST01_] end Log. ---]
	// Intel(R) Core(TM) i9-10980XE CPU @ 3.00GHz   3.00 GHz
	// 最初のCPUテストはPython版よりも速く動作した
	//
	//[SYSLOG][□--INFO--□] [qzlogstest01] 経過時間=0.173000[秒]
	//tid=11552:0.000000[秒][--- [QZ_TEST01_] end Log. ---]
	//[SYSLOG][□--INFO--□] [qzlogstest01] 経過時間=0.173000[秒]
	//tid=11552:0.000000[秒][--- [QZ_TEST01_] end Log. ---]
	// なんと、Python3版のほうがパフォーマンスが良い strconv.Itoaが遅いのか
	// 以下、i7 同マシンのPython3 バージョン計測
	//#[SYSLOG][□--INFO--□] [Sample.py] 経過時間=0.118000[秒]
	//#2021-01-29 12:11:06:[------------ [PY_SMP_] end Log. ------------]
	//# i7-4770  CPU @ 3.40GHz   3.40 GHz (第4世代) 8スレッド だと 0.118000秒でした、そんなに変わらないですね
	//
	//[SYSLOG][□--INFO--□] [qzlogstest01] 経過時間=0.210000[秒]
	//tid=8252:0.000000[秒][--- [QZ_TEST01_] end Log. ---]
	// Intel(R) Core(TM) i5-3210M CPU @ 2.50GHz   2.50 GHz 古いNote PC HDD搭載機
	for i := 0; i < 20000; i++ {
		qzlogs.Log("hoge! =  " + strconv.Itoa(i))
	}

	qzlogs.ProfileTimeStop()
	qzlogs.LogTerm()

}
