package main

import (
	"fmt"
	"runtime"
	"time"

	"./lib/qzlogs"
)

func main() {

	qzlogs.LogInit("D:\\work\\qzlogstest\\cmd", "QZ_TEST02_", 0x8000, 1, 0, 0, 1)
	qzlogs.ProfileTimeStart("qztest02.go 計測")

	ret := hoge()
	if ret == 0 {
		qzlogs.MsgBox("スタック取得失敗", "hoge() Error")
		goto done
	}
	saitama()
	musako()
	omiya()
	chiba()
	azabu()
	kawaguchi()
	mount()

done:

	qzlogs.ProfileTimeStop()
	qzlogs.LogTerm()

}

func hoge() (ret int) {
	ret = 1

	qzlogs.Log("hoge() In!")

	_, file, line, ok := runtime.Caller(0)
	if !ok {
		fmt.Println("スタックトレースの取得失敗")
		ret = 0
		return ret
	}
	msg := fmt.Sprintf("file=%s 関数 hoge() line=%d でエラー発生(嘘ですが)", file, line)
	qzlogs.Log(msg)

	qzlogs.Log("hoge() Out!")

	return ret
}

func saitama() {
	qzlogs.Log("saitama() In!")

	qzlogs.Log("さいたまの浦和は凄いですよ。皆年収2千万の人ばかりらしいです")

	qzlogs.Log("saitama() Out!")
}

func musako() {
	qzlogs.Log("musako() In!")

	qzlogs.Log("ムサコは凄いですよ。地上200m以上に住んでいる人ばかりです。でも駅から近いのにホームまで時間がかかります")

	qzlogs.Log("musako() Out!")
}

func omiya() {
	qzlogs.Log("omiya() In!")

	qzlogs.Log("大宮こそキングオブさいたま! 新都心はまさに未来都市。でも銀座からタクシーで帰ると奥さんに叱られます")

	qzlogs.Log("omiya() Out!")
}

func chiba() {
	qzlogs.Log("chiba() In!")

	qzlogs.Log("おおっと、千葉こそ最強。千葉なのに『東京ディズニーランド』があるぜ。海も無いさいたまにだけは負けないぜ")

	qzlogs.Log("chiba() Out!")
}

func azabu() {
	qzlogs.Log("azabu() In!")

	qzlogs.Log("アテクシ、麻布から出たことありませんことよ。おほほほほほほ～")

	qzlogs.Log("azabu() Out!")
}

func kawaguchi() {
	qzlogs.Log("kawaguchi() In!")

	qzlogs.Log("ふふっ、見栄さえはらなきゃ川口最強。荒川こえるだけで赤羽だからね。")

	qzlogs.Log("kawaguchi() Out!")
}

func mount() {
	qzlogs.Log("mount() In!")

	qzlogs.Log("住んでるとこでマウントするのやめて(*'ω'*) ここでわざとsleepしますね")
	qzlogs.Log("開発で疲れて、わるふざけが過ぎました。ごめんなさい Cool Bar!")

	time.Sleep(time.Millisecond * 200) // 200ミリ秒

	qzlogs.Log("mount() Out!")
}
